--------------------------------------------------------------------------------
---- Modificaci de Dades per el test del sistema ------------------------------
--------------------------------------------------------------------------------

DECLARE

RSP VARCHAR2(200);
nul VARCHAR2(50);
CURSOR C4 IS SELECT codi FROM CIUTADA ORDER BY codi;
v1 VARCHAR2(50);
P DATE;
O DATE;
T DATE;
num NUMBER;
id1 NUMBER;

BEGIN

--------------------------------------------------------------------------------
-------- Fem modificacions amb els Ciutadans -----------------------------------
--------------------------------------------------------------------------------

--- Els primers 15 Ciutadans s'hauran canviat a Tarragona i la seva data de 
--- naixement ser 10/01/1990.

  --- Obrim el cursor de Ciutadans
  OPEN C4;
  --- Definim una data de neixement comuna
  O := '10/01/1990';
  num := 0;
  LOOP    
    --- Fem un recorregut per tots ells
    FETCH C4 INTO id1;
    --- Si no hi han ms Ciutadans sortim
    EXIT WHEN num = 15;
      --- Modifiquem els Ciutadans
      MODIFICAR_CIUTADA(id1, O, 'ES_CAT_TARR', 'ES_CAT', 'ES', RSP); 
      --- Controlem les noves inscripcions als censos dels Ciutadans
      ALTA_INSCRIPCIO(id1, O, RSP);
      num := num + 1;
  END LOOP;
  --- Tanquem el cursor
  CLOSE C4;
  
--------------------------------------------------------------------------------
----- Fem modificacions a les Opcions de les Votacions en Edici ---------------
--------------------------------------------------------------------------------

  MODIFICAR_OPCIO(50, 'Si, amb prudncia', RSP);
  MODIFICAR_OPCIO(32, 'Si, amb prudncia', RSP);
  MODIFICAR_OPCIO(33, 'No, en absolut', RSP);
  MODIFICAR_OPCIO(41, 'Si, definitivament', RSP);
  MODIFICAR_OPCIO(42, 'No, en absolut', RSP);
  
--------------------------------------------------------------------------------
------ Modifiquem Votacions en edici ------------------------------------------
--------------------------------------------------------------------------------

  --- Indiquem noves dates
  SELECT data_publicacio INTO P FROM VOTACIO WHERE titol ='Obertura Atlantica';
  O := P + 8;
  T := O + 3;  
  MODIFICAR_VOTACIO('Obertura Atlantica', P, O, T, 'Carme Garrido Garrido', nul,
					'http://www.europa.eu/consultes/exteriors/america_latina/central', RSP); 
  SELECT data_publicacio INTO P FROM VOTACIO WHERE titol ='Sortir Euro';
  O := P + 8;
  T := O + 3;
  MODIFICAR_VOTACIO('Sortir Euro', P, O, T, nul, 
					'Est d''acord que el seu Pas abandoni la zona euro. Si; No o Vot en blanc', nul, RSP);
	  
--------------------------------------------------------------------------------
----- Modifiquem l'estat de les Votacions --------------------------------------
--------------------------------------------------------------------------------

  --- Estat Pendent
  MODIFICAR_ESTAT_VOTACIO('Entrar Euro', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Riera Premia', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Constitucio Europea', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Millora Platges', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Depuradora Maresme', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Premia Mar i Dalt', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Premia Mar Masnou', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Terme Barcelona', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Europarlament 2010', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Corredor Mediterrani', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Corredor Central', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Atlantic Nord', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Banc Central', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Eurobons', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Mesures ES Crisis', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Mesures PT Crisis', 'Pendent', RSP);
  MODIFICAR_ESTAT_VOTACIO('Ampliacio UE', 'Pendent', RSP);

  --- Estat Oberta
  MODIFICAR_ESTAT_VOTACIO('Entrar Euro', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Riera Premia', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Constitucio Europea', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Millora Platges', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Depuradora Maresme', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Premia Mar i Dalt', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Premia Mar Masnou', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Terme Barcelona', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Europarlament 2010', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Corredor Mediterrani', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Corredor Central', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Banc Central', 'Oberta', RSP);
  MODIFICAR_ESTAT_VOTACIO('Ampliacio UE', 'Oberta', RSP);
  
  --- En aquests moments podem fer les proves de Votaci amb l'script Proves Vot correctes.sql

  --- Validem totes les transaccions.
  COMMIT;
END;
/