--------------------------------------------------------------------------------
---- Inserci de Dades per el test del sistema ---------------------------------
--------------------------------------------------------------------------------

-- Per la realitzaci correcta d'aquestes proves s'ha d'haver executat previament
-- l'script "Proves Modificaci correctes.sql", per poder dispossar de Votacions Obertes.

--- L'execuci triga ms o menys 50".

DECLARE

RSP VARCHAR2(200);
CURSOR C5 IS SELECT ciutada 
             FROM INSCRIPCIO 
             WHERE cens IN (SELECT cens 
                            FROM ASSIGNACIO 
                            WHERE votacio = 'Corredor Mediterrani')
             ORDER BY ciutada;
dn DATE;
num NUMBER;
id1 NUMBER;
id2 NUMBER;

BEGIN

--------------------------------------------------------------------------------
---- Fem Votar a x Ciutadans en alguna Votaci ---------------------------------
--------------------------------------------------------------------------------
    
  --------------------------------
  --- Votaci Corredor Mediterrani
  --------------------------------
  --- Esbrinem la data d'obertura de la Votaci
  SELECT data_obertura INTO dn FROM VOTACIO WHERE titol = 'Corredor Mediterrani';
  num := 0;
  --- Esbrinem la primera Opci de Vot
  SELECT codi INTO id2 FROM (SELECT codi FROM OPCIO 
              WHERE votacio = 'Corredor Mediterrani' ORDER BY codi) 
  WHERE ROWNUM = 1;
  --- Obrim el cursor de Ciutadans
  OPEN C5;
  LOOP    
    --- Fem un recorregut per els primers 622
    FETCH C5 INTO id1;
    --- Si no hi han ms Ciutadans o arribem als 1222 sortim
    EXIT WHEN C5%NOTFOUND OR num = 1250;
    --- Corredor Mediterrani (Opci 1)
    IF num <= 622 THEN 
      --- Vot del Ciutad
      VOTAR('Corredor Mediterrani', id1, id2, dn, RSP);
    END IF;
    --- Corredor Mediterrani (Opci 2)
    IF num > 622 AND num <= 870 THEN
      --- Vot del Ciutad
      VOTAR('Corredor Mediterrani', id1, (id2 + 1), dn, RSP);
    END IF;
    --- Corredor Mediterrani (Opci 3)
    IF num > 870 AND num <= 1222 THEN
      --- Vot del Ciutad
      VOTAR('Corredor Mediterrani', id1, (id2 + 2), dn, RSP);
    END IF;
    --- Corredor Mediterrani (Opci 4)
    IF num > 1222 AND num <= 1250 THEN
      --- Vot del Ciutad
      VOTAR('Corredor Mediterrani', id1, (id2 + 3), dn, RSP);
    END IF;
    num := num + 1;  
  END LOOP;  
  --- Tanquem el cursor
  CLOSE C5;
  
  --- Estat Tancada
  MODIFICAR_ESTAT_VOTACIO('Corredor Mediterrani', 'Tancada', RSP);
    
  --- En aquests moments podem comprovar la qualitat de les dades estadstiques
  --- sobre aquesta Votaci.
  
  --- Validem totes les transaccions.
  COMMIT;
END;
/