--------------------------------------------------------------------------------
---- Inserci de Dades per el test del sistema ---------------------------------
--------------------------------------------------------------------------------

-- Per la realitzaci correcta d'aquestes proves s'ha d'haver executat previament
-- l'script "Proves Modificaci correctes.sql", per poder dispossar de Votacions Obertes.

--- L'execuci triga ms o menys 5".

DECLARE

RSP VARCHAR2(200);
CURSOR C5 IS SELECT ciutada 
             FROM INSCRIPCIO 
             WHERE cens IN (SELECT cens 
                            FROM ASSIGNACIO 
                            WHERE votacio = 'Depuradora Maresme')
             ORDER BY ciutada;
dn DATE;
num NUMBER;
id1 NUMBER;
id2 NUMBER;

BEGIN

--------------------------------------------------------------------------------
---- Fem Votar a x Ciutadans en alguna Votaci ---------------------------------
--------------------------------------------------------------------------------
    
  ------------------------------
  --- Votaci Depuradora Maresme
  ------------------------------
  --- Esbrinem la data d'obertura de la Votaci
  SELECT data_obertura INTO dn FROM VOTACIO WHERE titol = 'Depuradora Maresme';
  num := 0;
  --- Esbrinem la primera Opci de Vot
  SELECT codi INTO id2 FROM (SELECT codi FROM OPCIO 
              WHERE votacio = 'Depuradora Maresme' ORDER BY codi) 
  WHERE ROWNUM = 1;
  --- Obrim el cursor de Ciutadans
  OPEN C5;
  LOOP    
    --- Fem un recorregut per els primers 40
    FETCH C5 INTO id1;
    --- Si no hi han ms Ciutadans o arribem als 100 sortim
    EXIT WHEN C5%NOTFOUND OR num = 120;
    --- Depuradora Maresme (Opci 1)
    IF num <= 40 THEN 
      --- Vot del Ciutad
      VOTAR('Depuradora Maresme', id1, id2, dn, RSP);
    END IF;
    --- Depuradora Maresme (Opci 2)
    IF num > 40 AND num <= 60 THEN
      --- Vot del Ciutad
      VOTAR('Depuradora Maresme', id1, (id2 + 1), dn, RSP);
    END IF;
    --- Depuradora Maresme (Opci 3)
    IF num > 60 AND num <= 100 THEN
      --- Vot del Ciutad
      VOTAR('Depuradora Maresme', id1, (id2 + 2), dn, RSP);
    END IF;
     --- Depuradora Maresme (Opci 4)
    IF num > 100 AND num <= 120 THEN
      --- Vot del Ciutad
      VOTAR('Depuradora Maresme', id1, (id2 + 3), dn, RSP);
    END IF;
    num := num + 1;  
  END LOOP;  
  --- Tanquem el cursor
  CLOSE C5;
  
  --- Estat Tancada
  MODIFICAR_ESTAT_VOTACIO('Depuradora Maresme', 'Tancada', RSP);
    
  --- En aquests moments podem comprovar la qualitat de les dades estadstiques
  --- sobre aquesta Votaci.
  
  --- Validem totes les transaccions.
  COMMIT;
END;
/