--------------------------------------------------------------------------------
---- Inserci de Dades per el test del sistema ---------------------------------
--------------------------------------------------------------------------------

-- Per la realitzaci correcta d'aquestes proves s'ha d'haver executat previament
-- l'script "Proves Modificaci correctes.sql", per poder dispossar de Votacions Obertes.

--- L'execuci triga ms o menys 7".

DECLARE

RSP VARCHAR2(200);
CURSOR C5 IS SELECT ciutada 
             FROM INSCRIPCIO 
             WHERE cens IN (SELECT cens 
                            FROM ASSIGNACIO 
                            WHERE votacio = 'Millora Platges')
             ORDER BY ciutada;
dn DATE;
num NUMBER;
id1 NUMBER;
id2 NUMBER;

BEGIN

--------------------------------------------------------------------------------
---- Fem Votar a x Ciutadans en alguna Votaci ---------------------------------
--------------------------------------------------------------------------------
    
  ---------------------------
  --- Votaci Millora Platges
  ---------------------------
  --- Esbrinem la data d'obertura de la Votaci
  SELECT data_obertura INTO dn FROM VOTACIO WHERE titol = 'Millora Platges';
  num := 0;
  --- Esbrinem la primera Opci de Vot
  SELECT codi INTO id2 FROM (SELECT codi FROM OPCIO 
              WHERE votacio = 'Millora Platges' ORDER BY codi) 
  WHERE ROWNUM = 1;
  --- Obrim el cursor de Ciutadans
  OPEN C5;
  LOOP    
    --- Fem un recorregut per els primers 93
    FETCH C5 INTO id1;
    --- Si no hi han ms Ciutadans o arribem als 93 sortim
    EXIT WHEN C5%NOTFOUND OR num = 150;
    --- Millora Platges (Opci 1)
    IF num <= 80 THEN 
      --- Vot del Ciutad
      VOTAR('Millora Platges', id1, id2, dn, RSP);
    END IF;
    --- Millora Platges (Opci 2)
    IF num > 80 AND num <= 100 THEN
      --- Vot del Ciutad
      VOTAR('Millora Platges', id1, (id2 + 1), dn, RSP);
    END IF;
    --- Millora Platges (Opci 3)
    IF num > 100 AND num <= 150 THEN
      --- Vot del Ciutad
      VOTAR('Millora Platges', id1, (id2 + 2), dn, RSP);
    END IF;
    num := num + 1;  
  END LOOP;  
  --- Tanquem el cursor
  CLOSE C5;
  
  --- Estat Tancada
  MODIFICAR_ESTAT_VOTACIO('Millora Platges', 'Tancada', RSP);
    
  --- En aquests moments podem comprovar la qualitat de les dades estadstiques
  --- sobre aquesta Votaci.
  
  --- Validem totes les transaccions.
  COMMIT;
END;
/