--------------------------------------------------------------------------------
--- Script per eliminar tots els components de la Base de Dades ----------------
--------------------------------------------------------------------------------

BEGIN

--- Eliminem els Procediments emmagatzemats
EXECUTE IMMEDIATE 'DROP PROCEDURE ALTA_ASSIGNACIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE ALTA_CENS';
EXECUTE IMMEDIATE 'DROP PROCEDURE ALTA_CIUTADA';
EXECUTE IMMEDIATE 'DROP PROCEDURE ALTA_INSCRIPCIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE ALTA_OPCIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE ALTA_VOTACIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE BAIXA_ASSIGNACIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE BAIXA_CENS';
EXECUTE IMMEDIATE 'DROP PROCEDURE BAIXA_CIUTADA';
EXECUTE IMMEDIATE 'DROP PROCEDURE BAIXA_INSCRIPCIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE BAIXA_OPCIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE BAIXA_VOTACIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE LLISTAT';
EXECUTE IMMEDIATE 'DROP PROCEDURE MODIFICAR_CIUTADA';
EXECUTE IMMEDIATE 'DROP PROCEDURE MODIFICAR_ESTAT_VOTACIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE MODIFICAR_OPCIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE MODIFICAR_VOTACIO';
EXECUTE IMMEDIATE 'DROP PROCEDURE VOTAR';

--- Eliminem les taules amb els seus Triggers i Disparadors
EXECUTE IMMEDIATE 'DROP TABLE GRUP_EST';
EXECUTE IMMEDIATE 'DROP TABLE EST_PAIS_ANY';
EXECUTE IMMEDIATE 'DROP TABLE EST_CENS_ANY';

EXECUTE IMMEDIATE 'DROP TRIGGER INSERT_CODI_TAULA_LOGS';
EXECUTE IMMEDIATE 'DROP TABLE TAULA_LOGS';
EXECUTE IMMEDIATE 'DROP SEQUENCE SEC_TAULA_LOGS';

EXECUTE IMMEDIATE 'DROP TRIGGER NO_EDIT_BORR_VOT';
EXECUTE IMMEDIATE 'DROP TABLE VOT';

EXECUTE IMMEDIATE 'DROP TRIGGER INSERT_CODI_OPCIO';
EXECUTE IMMEDIATE 'DROP TABLE OPCIO';
EXECUTE IMMEDIATE 'DROP SEQUENCE SEC_OPCIO';

EXECUTE IMMEDIATE 'DROP TABLE ASSIGNACIO';
EXECUTE IMMEDIATE 'DROP TABLE INSCRIPCIO';

EXECUTE IMMEDIATE 'DROP TABLE VOTACIO';
EXECUTE IMMEDIATE 'DROP TABLE CIUTADA';

EXECUTE IMMEDIATE 'DROP TABLE CENS_LOCAL';
EXECUTE IMMEDIATE 'DROP TABLE CENS_REGIO';
EXECUTE IMMEDIATE 'DROP TABLE CENS_ESTAT';
EXECUTE IMMEDIATE 'DROP TABLE CENS';

EXECUTE IMMEDIATE 'DROP TABLE LOCALITAT';
EXECUTE IMMEDIATE 'DROP TABLE REGIO';
EXECUTE IMMEDIATE 'DROP TABLE ESTAT';

END;
/