--------------------------------------------------------------------------------
---- Inserci de les dades inicials del sistema --------------------------------
--------------------------------------------------------------------------------

BEGIN

--------------------------------------------------------------------------------
---| Inseci de dades a la taula Estat |----------------------------------------
--------------------------------------------------------------------------------

INSERT INTO ESTAT 
  SELECT 'DE', 'Alemania' FROM DUAL
  UNION ALL
  SELECT 'A', 'Austria' FROM DUAL
  UNION ALL
  SELECT 'BG', 'Bulgaria' FROM DUAL
  UNION ALL
  SELECT 'SER', 'Blgica' FROM DUAL
  UNION ALL
  SELECT 'CZ', 'Chequia' FROM DUAL
  UNION ALL
  SELECT 'CY', 'Chipre' FROM DUAL
  UNION ALL
  SELECT 'DK', 'Dinamarca' FROM DUAL
  UNION ALL
  SELECT 'SK', 'Eslovaquia' FROM DUAL
  UNION ALL
  SELECT 'SI', 'Eslovenia' FROM DUAL
  UNION ALL  
  SELECT 'ES', 'Espaa' FROM DUAL
  UNION ALL
  SELECT 'EE', 'Estonia' FROM DUAL
  UNION ALL
  SELECT 'FI', 'Finlandia' FROM DUAL
  UNION ALL
  SELECT 'FR', 'Francia' FROM DUAL
  UNION ALL
  SELECT 'GR', 'Grecia' FROM DUAL
  UNION ALL
  SELECT 'IT', 'Italia' FROM DUAL
  UNION ALL
  SELECT 'LU', 'Luxemburgo' FROM DUAL
  UNION ALL
  SELECT 'NL', 'Holanda' FROM DUAL
  UNION ALL
  SELECT 'PT', 'Portugal' FROM DUAL
  UNION ALL
  SELECT 'GB', 'Gran Bretaa' FROM DUAL
  UNION ALL
  SELECT 'HU', 'Hungra' FROM DUAL
  UNION ALL
  SELECT 'IE', 'Irlanda' FROM DUAL
  UNION ALL
  SELECT 'LV', 'Letonia' FROM DUAL
  UNION ALL
  SELECT 'LT', 'Lituania' FROM DUAL
  UNION ALL
  SELECT 'MT', 'Malta' FROM DUAL
  UNION ALL
  SELECT 'PL', 'Polonia' FROM DUAL
  UNION ALL
  SELECT 'RU', 'Rumana' FROM DUAL
  UNION ALL
  SELECT 'SE', 'Suecia' FROM DUAL;

COMMIT;

--------------------------------------------------------------------------------
-----| Inserci de dades a la taula Regi |-------------------------------------
--------------------------------------------------------------------------------

INSERT INTO REGIO
  SELECT 'ES_AND', 'ES', 'Andaluca' FROM DUAL
  UNION ALL
  SELECT 'ES_ARG', 'ES', 'Aragn' FROM DUAL
  UNION ALL
  SELECT 'ES_AST', 'ES', 'Asturias' FROM DUAL
  UNION ALL
  SELECT 'ES_CAN', 'ES', 'Cantabria' FROM DUAL
  UNION ALL
  SELECT 'ES_CLM', 'ES', 'Castilla La Mancha' FROM DUAL
  UNION ALL
  SELECT 'ES_CLE', 'ES', 'Castilla Len' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT', 'ES', 'Catalunya' FROM DUAL
  UNION ALL
  SELECT 'ES_CEU', 'ES', 'Ciudad Autnoma de Ceuta' FROM DUAL
  UNION ALL
  SELECT 'ES_MEL', 'ES', 'Ciudad Autnoma de Melilla' FROM DUAL
  UNION ALL
  SELECT 'ES_EXT', 'ES', 'Extremadura' FROM DUAL
  UNION ALL
  SELECT 'ES_GAL', 'ES', 'Galicia' FROM DUAL
  UNION ALL
  SELECT 'ES_IBA', 'ES', 'Illes Balears' FROM DUAL
  UNION ALL
  SELECT 'ES_ICA', 'ES', 'Islas Canarias' FROM DUAL
  UNION ALL
  SELECT 'ES_RIO', 'ES', 'La Rioja' FROM DUAL
  UNION ALL
  SELECT 'ES_MUR', 'ES', 'Comunidad de Murcia' FROM DUAL
  UNION ALL
  SELECT 'ES_NAV', 'ES', 'Navarra' FROM DUAL
  UNION ALL
  SELECT 'ES_EUS', 'ES', 'Euskadi' FROM DUAL
  UNION ALL
  SELECT 'ES_MAD', 'ES', 'Comunidad de Madrid' FROM DUAL
  UNION ALL
  SELECT 'ES_VAL', 'ES', 'Comunitat Valenciana' FROM DUAL
  UNION ALL
  SELECT 'FR_AQU', 'FR', 'Aquitaine' FROM DUAL
  UNION ALL
  SELECT 'FR_ANM', 'FR', 'Alta Normanda' FROM DUAL
  UNION ALL  
  SELECT 'FR_BRE', 'FR', 'Bretagne' FROM DUAL
  UNION ALL
  SELECT 'FR_LRO', 'FR', 'Languedoc Roussillon' FROM DUAL
  UNION ALL
  SELECT 'FR_BOG', 'FR', 'Bourgogne' FROM DUAL
  UNION ALL
  SELECT 'FR_ALS', 'FR', 'Alsace' FROM DUAL
  UNION ALL
  SELECT 'DE_HES', 'DE', 'Hessen' FROM DUAL
  UNION ALL
  SELECT 'DE_BER', 'DE', 'Berlin' FROM DUAL
  UNION ALL
  SELECT 'DE_BRE', 'DE', 'Bremen' FROM DUAL
  UNION ALL
  SELECT 'DE_HAM', 'DE', 'Hamburg' FROM DUAL
  UNION ALL
  SELECT 'DE_SAC', 'DE', 'Sachsen' FROM DUAL
  UNION ALL
  SELECT 'PT_ALG', 'PT', 'Regin del Algarve' FROM DUAL
  UNION ALL
  SELECT 'PT_ALE', 'PT', 'Regin del Alentejo' FROM DUAL
  UNION ALL
  SELECT 'PT_CEN', 'PT', 'Regin Centro' FROM DUAL
  UNION ALL
  SELECT 'PT_LIS', 'PT', 'Regin de Lisboa' FROM DUAL
  UNION ALL
  SELECT 'GB_LON', 'GB', 'Greater London' FROM DUAL
  UNION ALL
  SELECT 'GB_WML', 'GB', 'West Midlands' FROM DUAL
  UNION ALL
  SELECT 'GB_YOH', 'GB', 'Yorkshire and the Humber' FROM DUAL
  UNION ALL
  SELECT 'GB_EML', 'GB', 'East Midlands' FROM DUAL
  UNION ALL
  SELECT 'GB_EEN', 'GB', 'East of England' FROM DUAL;
  
COMMIT;

--------------------------------------------------------------------------------
----| Inserci de dades a la tula Localitat |----------------------------------
--------------------------------------------------------------------------------
INSERT INTO LOCALITAT
  SELECT 'ES_AND_SEVI', 'ES_AND', 'ES', 'Sevilla' FROM DUAL
  UNION ALL
  SELECT 'ES_AND_GRAN', 'ES_AND', 'ES', 'Granada' FROM DUAL
  UNION ALL
  SELECT 'ES_AND_SFER', 'ES_AND', 'ES', 'San Fernando' FROM DUAL
  UNION ALL
  SELECT 'ES_AND_CADI', 'ES_AND', 'ES', 'Cdiz' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_PREM', 'ES_CAT', 'ES', 'Premi de Mar' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_PRED', 'ES_CAT', 'ES', 'Premi de Dalt' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_MASN', 'ES_CAT', 'ES', 'El Masnou' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_HOSP', 'ES_CAT', 'ES', 'Hospitalet' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_VILM', 'ES_CAT', 'ES', 'Vilassar de Mar' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_BARC', 'ES_CAT', 'ES', 'Barcelona' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_TARR', 'ES_CAT', 'ES', 'Tarragona' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_LLEI', 'ES_CAT', 'ES', 'Lleida' FROM DUAL
  UNION ALL
  SELECT 'ES_CAT_GIRO', 'ES_CAT', 'ES', 'Girona' FROM DUAL
  UNION ALL
  SELECT 'DE_HES_WIES', 'DE_HES', 'DE', 'Wiesbaden' FROM DUAL
  UNION ALL
  SELECT 'GB_LON_LOND', 'GB_LON', 'GB', 'City of London' FROM DUAL
  UNION ALL
  SELECT 'GB_YOH_LEED', 'GB_YOH', 'GB', 'Leeds' FROM DUAL
  UNION ALL
  SELECT 'GB_YOH_BRAD', 'GB_YOH', 'GB', 'Bradford' FROM DUAL
  UNION ALL
  SELECT 'GB_YOH_YORK', 'GB_YOH', 'GB', 'York' FROM DUAL
  UNION ALL
  SELECT 'PT_LIS_LISB', 'PT_LIS', 'PT', 'Lisboa' FROM DUAL
  UNION ALL
  SELECT 'PT_ALG_ALTE', 'PT_ALG', 'PT', 'Alte' FROM DUAL
  UNION ALL
  SELECT 'PT_ALG_CMCH', 'PT_ALG', 'PT', 'Caldas de Monchique' FROM DUAL
  UNION ALL
  SELECT 'PT_ALG_ALJZ', 'PT_ALG', 'PT', 'Aljezur' FROM DUAL
  UNION ALL
  SELECT 'PT_ALG_ODXE', 'PT_ALG', 'PT', 'Odeceixe' FROM DUAL
  UNION ALL
  SELECT 'FR_ANM_FECM', 'FR_ANM', 'FR', 'Fcamp' FROM DUAL
  UNION ALL
  SELECT 'FR_ANM_ELBF', 'FR_ANM', 'FR', 'Elbeuf' FROM DUAL
  UNION ALL
  SELECT 'FR_ANM_DIEP', 'FR_ANM', 'FR', 'Dieppe' FROM DUAL
  UNION ALL
  SELECT 'FR_LRO_MOTP', 'FR_LRO', 'FR', 'Montpellier' FROM DUAL
  UNION ALL
  SELECT 'FR_LRO_CARC', 'FR_LRO', 'FR', 'Carcasone' FROM DUAL
  UNION ALL
  SELECT 'FR_LRO_CASN', 'FR_LRO', 'FR', 'Castelnou' FROM DUAL
  UNION ALL
  SELECT 'FR_LRO_BEZI', 'FR_LRO', 'FR', 'Beziers' FROM DUAL
  UNION ALL
  SELECT 'FR_LRO_PERP', 'FR_LRO', 'FR', 'Perpignan' FROM DUAL
  UNION ALL
  SELECT 'DE_HES_HAID', 'DE_HES', 'DE', 'Haid' FROM DUAL
  UNION ALL
  SELECT 'DE_HES_FRFU', 'DE_HES', 'DE', 'Frankfurt' FROM DUAL
  UNION ALL
  SELECT 'DE_BER_DAHL', 'DE_BER', 'DE', 'Dahlem' FROM DUAL
  UNION ALL
  SELECT 'DE_BER_BERL', 'DE_BER', 'DE', 'Berlin' FROM DUAL
  UNION ALL
  SELECT 'PT_LIS_ESTO', 'PT_LIS', 'PT', 'Estoril' FROM DUAL;
  
COMMIT;

--------------------------------------------------------------------------------
--- Incialitzaci mnima de la taula Cens: 
--- Cens Global al qual pertanyen tots els Ciutadans ---------------------------
INSERT INTO CENS VALUES ('Europa', 'Global', 0);
--- Tamb es pot realitzar aquesta alta amb el procediment creat a tal efecte
--------------------------------------------------------------------------------

COMMIT;

--------------------------------------------------------------------------------
-----| Iniciaci de la taula Grup_Est |-----------------------------------------
--------------------------------------------------------------------------------

INSERT INTO GRUP_EST (codi)
  SELECT 'VotaMesParticipacio' FROM DUAL
  UNION ALL
  SELECT 'VotaMesDifOpcions' FROM DUAL
  UNION ALL
  SELECT 'VotaMenysDifOpcions' FROM DUAL
  UNION ALL
  SELECT 'NMaxVota1Persona' FROM DUAL;

COMMIT;

END;
/

