--------------------------------------------------------------------------------
---- Inserci de Dades per el test del sistema ---------------------------------
--------------------------------------------------------------------------------

-- Per la realitzaci correcta d'aquestes proves s'ha d'haver executat previament
-- l'script "Proves Modificaci correctes.sql", per poder dispossar de Votacions Obertes.

--- L'execuci triga ms o menys 45".

DECLARE

RSP VARCHAR2(200);
CURSOR C4 IS SELECT ciutada 
             FROM INSCRIPCIO 
             WHERE cens IN (SELECT cens 
                            FROM ASSIGNACIO 
                            WHERE votacio = 'Banc Central')
             ORDER BY ciutada;
dn DATE;
num NUMBER;
id1 NUMBER;
id2 NUMBER;

BEGIN

--------------------------------------------------------------------------------
---- Fem Votar a x Ciutadans en alguna Votaci ---------------------------------
--------------------------------------------------------------------------------
    
  ------------------------
  --- Votaci Banc Central
  ------------------------
  --- Esbrinem la data d'obertura de la Votaci
  SELECT data_obertura INTO dn FROM VOTACIO WHERE titol = 'Banc Central';
  num := 0;
  --- Esbrinem la primera Opci de Vot
  SELECT codi INTO id2 FROM (SELECT codi FROM OPCIO 
              WHERE votacio = 'Banc Central' ORDER BY codi) 
  WHERE ROWNUM = 1;
  --- Obrim el cursor de Ciutadans
  OPEN C4;
  LOOP    
    --- Fem un recorregut per els primers 650
    FETCH C4 INTO id1;
    --- Si no hi han ms Ciutadans o arribem als 1350 sortim
    EXIT WHEN C4%NOTFOUND OR num = 1350;
    --- Banc Central (Opci 1)
    IF num <= 650 THEN 
      --- Vot del Ciutad
      VOTAR('Banc Central', id1, id2, dn, RSP);
    END IF;
    --- Banc Central (Opci 2)
    IF num > 650 AND num <= 1100 THEN
      --- Vot del Ciutad
      VOTAR('Banc Central', id1, (id2 + 1), dn, RSP);
    END IF;
    --- Banc Central (Opci 3)
    IF num > 1100 AND num <= 1350 THEN
      --- Vot del Ciutad
      VOTAR('Banc Central', id1, (id2 + 2), dn, RSP);
    END IF;
    num := num + 1;  
  END LOOP;  
  --- Tanquem el cursor
  CLOSE C4; 
  
  --- Estat Tancada
  MODIFICAR_ESTAT_VOTACIO('Banc Central', 'Tancada', RSP);
    
  --- En aquests moments podem comprovar la qualitat de les dades estadstiques
  --- sobre aquesta Votaci.
  
  --- Validem totes les transaccions.
  COMMIT;
END;
/