--------------------------------------------------------------------------------
---- Inserci de Dades per el test del sistema ---------------------------------
--------------------------------------------------------------------------------

-- Per la realitzaci correcta d'aquestes proves s'ha d'haver executat previament
-- l'script "Proves Modificaci correctes.sql", per poder dispossar de Votacions Obertes.

--- L'execuci triga ms o menys 5".

DECLARE

RSP VARCHAR2(200);
CURSOR C5 IS SELECT ciutada 
             FROM INSCRIPCIO 
             WHERE cens IN (SELECT cens 
                            FROM ASSIGNACIO 
                            WHERE votacio = 'Premia Mar i Dalt')
             ORDER BY ciutada;
dn DATE;
num NUMBER;
id1 NUMBER;
id2 NUMBER;

BEGIN

--------------------------------------------------------------------------------
---- Fem Votar a x Ciutadans en alguna Votaci ---------------------------------
--------------------------------------------------------------------------------
    
  -----------------------------
  --- Votaci Premia Mar i Dalt
  -----------------------------
  --- Esbrinem la data d'obertura de la Votaci
  SELECT data_obertura INTO dn FROM VOTACIO WHERE titol = 'Premia Mar i Dalt';
  num := 0;
  --- Esbrinem la primera Opci de Vot
  SELECT codi INTO id2 FROM (SELECT codi FROM OPCIO 
              WHERE votacio = 'Premia Mar i Dalt' ORDER BY codi) 
  WHERE ROWNUM = 1;
  --- Obrim el cursor de Ciutadans
  OPEN C5;
  LOOP    
    --- Fem un recorregut per els primers 43
    FETCH C5 INTO id1;
    --- Si no hi han ms Ciutadans o arribem als 90 sortim
    EXIT WHEN C5%NOTFOUND OR num = 88;
    --- Premia Mar i Dalt (Opci 1)
    IF num <= 43 THEN 
      --- Vot del Ciutad
      VOTAR('Premia Mar i Dalt', id1, (id2 + 1), dn, RSP);
    END IF;
    --- Premia Mar i Dalt (Opci 2)
    IF num > 43 AND num <= 59 THEN
      --- Vot del Ciutad
      VOTAR('Premia Mar i Dalt', id1, id2, dn, RSP);
    END IF;
    --- Premia Mar i Dalt (Opci 3)
    IF num > 59 AND num <= 88 THEN
      --- Vot del Ciutad
      VOTAR('Premia Mar i Dalt', id1, (id2 + 2), dn, RSP);
    END IF;
    num := num + 1;  
  END LOOP;  
  --- Tanquem el cursor
  CLOSE C5;
  
  --- Estat Tancada
  MODIFICAR_ESTAT_VOTACIO('Premia Mar i Dalt', 'Tancada', RSP);
    
  --- En aquests moments podem comprovar la qualitat de les dades estadstiques
  --- sobre aquesta Votaci.
  
  --- Validem totes les transaccions.
  COMMIT;
END;
/