--------------------------------------------------------------------------------
---- Inserci de Dades per el test del sistema ---------------------------------
--------------------------------------------------------------------------------

-- Per la realitzaci correcta d'aquestes proves s'ha d'haver executat previament
-- l'script "Proves Modificaci correctes.sql", per poder dispossar de Votacions Obertes.

--- L'execuci triga ms o menys 5".

DECLARE

RSP VARCHAR2(200);
CURSOR C5 IS SELECT ciutada 
             FROM INSCRIPCIO 
             WHERE cens IN (SELECT cens 
                            FROM ASSIGNACIO 
                            WHERE votacio = 'Terme Barcelona')
             ORDER BY ciutada DESC;
dn DATE;
num NUMBER;
id1 NUMBER;
id2 NUMBER;

BEGIN

--------------------------------------------------------------------------------
---- Fem Votar a x Ciutadans en alguna Votaci ---------------------------------
--------------------------------------------------------------------------------
    
  ---------------------------
  --- Votaci Terme Barcelona
  ---------------------------
  --- Esbrinem la data d'obertura de la Votaci
  SELECT data_obertura INTO dn FROM VOTACIO WHERE titol = 'Terme Barcelona';
  num := 0;
  --- Esbrinem la primera Opci de Vot
  SELECT codi INTO id2 FROM (SELECT codi FROM OPCIO 
              WHERE votacio = 'Terme Barcelona' ORDER BY codi) 
  WHERE ROWNUM = 1;
  --- Obrim el cursor de Ciutadans
  OPEN C5;
  LOOP    
    --- Fem un recorregut per els primers 43
    FETCH C5 INTO id1;
    --- Si no hi han ms Ciutadans o arribem als 89 sortim
    EXIT WHEN C5%NOTFOUND OR num = 45;
    --- Terme Barcelona (Opci 1)
    IF num <= 23 THEN 
      --- Vot del Ciutad
      VOTAR('Terme Barcelona', id1, (id2 + 1), dn, RSP);
    END IF;
    --- Terme Barcelona (Opci 2)
    IF num > 23 AND num <= 30 THEN
      --- Vot del Ciutad
      VOTAR('Terme Barcelona', id1, id2, dn, RSP);
    END IF;
    --- Terme Barcelona (Opci 3)
    IF num > 30 AND num <= 40 THEN
      --- Vot del Ciutad
      VOTAR('Terme Barcelona', id1, (id2 + 2), dn, RSP);
    END IF;
    --- Terme Barcelona (Opci 4)
    IF num > 40 AND num <= 45 THEN
      --- Vot del Ciutad
      VOTAR('Terme Barcelona', id1, (id2 + 3), dn, RSP);
    END IF;
    num := num + 1;  
  END LOOP;  
  --- Tanquem el cursor
  CLOSE C5;
  
  --- Estat Tancada
  MODIFICAR_ESTAT_VOTACIO('Terme Barcelona', 'Tancada', RSP);
    
  --- En aquests moments podem comprovar la qualitat de les dades estadstiques
  --- sobre aquesta Votaci.
  
  --- Validem totes les transaccions.
  COMMIT;
END;
/